package Agent;

import java.io.*;
import java.net.*;


// Questa classe si occupa della singola connessione col client.
public class AgentHandler extends Thread {

  protected AgentServer server;
  protected Socket socket;
  protected String agentLoaderClassName;

  public AgentHandler (AgentServer server, Socket socket) {
    this.server = server;
    this.socket = socket;
    agentLoaderClassName = new String ("Agent.DefaultAgentLoader");
  }

  public AgentHandler (AgentServer server, Socket socket, String agLoad) {
    this.server = server;
    this.socket = socket;
    agentLoaderClassName = agLoad;
  }

  public void run() {
    startAgentLoader();
  }

  protected void startAgentLoader() {
    try {
      // Istanziazione di un nuovo class loader
      AgentClassLoader loader = new AgentClassLoader();
      // Aggiunge nella tabella hash della cache la classe agentLoaderClassName
      loader.addClassBytes (agentLoaderClassName,
                            ClassBytesLoader.loadClassBytes(agentLoaderClassName));
      Class agentLoaderClass = loader.forceLoadClass (agentLoaderClassName);
      AgentLoader agentLoader = (AgentLoader) agentLoaderClass.newInstance();
      agentLoader.setServer (server);
      agentLoader.setInputStream (socket.getInputStream());
      agentLoader.setOutputStream (socket.getOutputStream());
      agentLoader.setSocket (socket);
      agentLoader.start();
    } catch ( Exception e ) {
        e.printStackTrace();
    }
  }

}
