package Agent;

// Estende quello di default in modo da gestire anche le classi
// utilizzate dalla classe

import java.io.*;
import java.net.*;
import java.util.*;


// Classe che riceve l'agente e lo manda in esecuzione
public class AgentLoaderEx extends DefaultAgentLoader {

  public AgentLoaderEx() { super(); }

  // Prima che venga mandato in esecuzione l'agente,
  // si aggiorna la tabella del class loader con le classi usate dall'agente 
  protected void startAgent (AgentPacket pack)
            throws ClassNotFoundException, IOException  {
    try {
      if ( pack instanceof AgentPacketEx ) {
        AgentPacketEx Pack = (AgentPacketEx) pack;
        reconstructAgent (Pack);
      }
      super.startAgent (pack);
    } catch ( ClassCastException cce ) {
        cce.printStackTrace();
    }
  }

  protected void reconstructAgent (AgentPacketEx pack) {
    AgentClassLoader cl = (AgentClassLoader) (getClass().getClassLoader());
    Enumeration en = pack.usedClasses.keys();
    String className;
    while ( en.hasMoreElements() ) {
      className = (String)en.nextElement();
      cl.addClassBytes ( className, (byte[])(pack.usedClasses.get(className)) );
    }
  }
}
