package Agent;

import java.io.*;
import java.util.Vector;
import java.util.Enumeration;


// Struttura che memorizza un agente e la sua classe
// Serve per mandare queste informazioni in rete

public class AgentPacket implements java.io.Serializable {

    public String className;   // Nome della classe
    public byte ClassBytes[];  // Bytes della classe
    public byte AgentBytes[];  // Contenuto dell'agente
    public byte FirmaBytes[];  // Indirizzo firmato per la certificazione

    public AgentPacket (Agent P, byte[] clBytes) {
      className = P.getClass().getName();
      ClassBytes = clBytes;
      try {
        // Memorizzazione dell'agente come array di byte
        ByteArrayOutputStream byteOStream = new ByteArrayOutputStream();
        ObjectOutputStream objOStream = new ObjectOutputStream (byteOStream);
        // Serializza e invia l'oggetto Agent al ByteArrayOutputStream
        objOStream.writeObject (P);
        AgentBytes = byteOStream.toByteArray();
      } catch ( IOException e ) {
          e.printStackTrace();
      }
    }

    public String toString() {
      return "AgentPacket : " + className;
    }
}
