package Agent;

import java.io.*;
import java.net.*;
import java.security.* ;
import java.util.Hashtable;


public class AgentServer extends Thread {

  protected final static int defaultPort = 9999;
  protected ServerSocket serversocket;

  // Queste variabili sono pubbliche 
  // in modo che l'agente possa accedervi
  // Lista dei "riferimenti conosciuti" 
  public static ListaTabelle Lista;
  // Lista delle entry eliminate
  public static ListaTabelle ListaEliminati;
  // Firma dell'indirizzo del nodo
  public static byte FirmaNodo[];
  // Lista delle chiavi 
  public static Hashtable KeyList;
  // Chiave pubblica dell'autorita' di certificazione
  public static PublicKey ChiaveCertif;
  // Chiavi server
  static Key PubKey;

  // Questa per ovvi motivi e' non accessibile
  // da parte degli agenti
  protected static Key PrivKey;

  // Porta e indirizzo server
  static String SerHost;
  static int port;  

  public AgentServer() throws IOException {
    super ("AgentServer on port " + AgentServer.defaultPort + " started.");
    port = AgentServer.defaultPort;
    serversocket = new ServerSocket (port);
  }

  public AgentServer (int port) throws IOException {
    super ("AgentServer on port " + port + " started." );
    this.port = port;
    serversocket = new ServerSocket (port);
  }
  
  public void run() {
    Socket socket;
    // Ciclo principale server
    try {
      while (true) {
        socket = serversocket.accept();
        System.out.println("Nuova connessione da " + socket.getInetAddress().getHostAddress() +
                           ":" + socket.getPort());
      	// Ad ogni connessione richiama l'AgentHandler 
      	newAgentHandler (this, socket);	
      }
    } catch ( IOException e ) {
        System.err.println (e);
    }
  }

  protected void newAgentHandler (AgentServer server, Socket socket) {
    AgentHandler Ahandler;
    // (server continua ad essere il riferimento all'AgentServer stesso)
    Ahandler = new AgentHandler (server, socket);
    Ahandler.start();
  }

  public static void main (String args[]) throws IOException {
    if ( args.length > 1 )
      throw new IOException ("Syntax : AgentServer { <port> }");
    int port = AgentServer.defaultPort;
    if ( args.length > 0 )
      port = Integer.parseInt(args[ 0 ]);
    System.out.println ("Starting AgentServer on port " + port);
    AgentServer agentServer = new AgentServer (port);
    agentServer.start();
  }
}
