package Agent;

import java.io.*;
import java.security.*;
import java.net.*;
import java.util.*;
import javax.crypto.*;
import iaik.security.rsa.*;


public class AgentServerEx extends AgentServer {

  // Variabile di gestione Versione per le proprie entry 
  static int SerVer;
  // Time 2 live degli agenti di coordinamento
  static int Time2LiveAgenti = 10;

  // Thread di controllo e comando
  static CommandThread command;
  static ControlThread controllore;

  protected String agentLoaderName = new String ("Agent.AgentLoaderEx");
 
  public AgentServerEx() throws IOException { super(); }

  public AgentServerEx (int port) throws IOException {
    super (port); 
  }

  public AgentServerEx (int port, String agLoad) throws IOException {
    super (port);
    agentLoaderName = agLoad;
  }

  protected void newAgentHandler (AgentServer server, Socket socket) {
    AgentHandler Ahandler;
    Ahandler = new AgentHandler (server, socket, agentLoaderName);
    Ahandler.start();
  }

  public static void main ( String args[] ) throws IOException {
    // Creo le liste
    Lista = new ListaTabelle();
    ListaEliminati = new ListaTabelle();
    KeyList = new Hashtable();
    // Prendo il separatore del path
    char path = System.getProperty("file.separator").charAt(0);
    if ( args.length > 5 )
      throw new IOException ("Syntax : AgentServerEx { <Porta> [<FileConfig>] [<FileFirmaNodo>] [<AgentLoaderName>] }");
    AgentServerEx agentServer;
    EntryLista en;
    Date Data = new Date();
    InetAddress SerAddress = InetAddress.getLocalHost();
    StringTokenizer st = new StringTokenizer(SerAddress.toString(),"/");
    st.nextToken();
    SerHost = st.nextToken();
    // SerHost = "127.0.0.1";
    SerVer = 1;
    switch ( args.length ) {
      case 3 :  
	 // Parametri passati : <Porta> <FileConfig> <FileFirmaNodo>
	 port = Integer.parseInt(args[0]);
         agentServer = new AgentServerEx(port);
         File myfile2 = new File(args[1]);
	 Lista.CompilaLista(myfile2);
         File FileFirma = new File("Certif" + path + args[2]);
       	 FileInputStream firm = new FileInputStream(FileFirma);
         FirmaNodo = new byte[50];
         try {
           firm.read(FirmaNodo);
         } catch (IOException ioe) {
             System.out.println ("Impossibile leggere la firma...");
         }
         break;
      case 4 :  
	 // Parametri passati : <Porta> <FileConfig> <FileFirmaNodo> <AgentLoaderName>
	 port = Integer.parseInt(args[0]);
         agentServer = new AgentServerEx(port,args[3]);
         myfile2 = new File(args[1]);
	 Lista.CompilaLista(myfile2);
         FileFirma = new File("Certif" + path + args[2]);
       	 firm = new FileInputStream(FileFirma);
         FirmaNodo = new byte[50];
         try {
           firm.read(FirmaNodo);
         } catch (IOException ioe) {
             System.out.println ("Impossibile leggere la firma...");
         }
         break;
      default:		
         throw new IOException ("Syntax : AgentServerEx { <Porta> <FileConfig> <FileFirmaNodo> [<AgentLoaderName>] }");
    }
    
    //Cicli di lettura delle chiavi
    try {
      // Chiave autorita' di certificatore
      File FileChiave = new File("PubKey" + path + "pubKey");
      FileInputStream fis = new FileInputStream(FileChiave);
      ObjectInputStream ois = new ObjectInputStream(fis);
      ChiaveCertif = (PublicKey) ois.readObject();
      ois.close();
      fis.close();
      // Chiavi server
      FileChiave = new File("PubKey" + path + args[2]);
      fis = new FileInputStream(FileChiave);
      ois = new ObjectInputStream(fis);
      PubKey =  (Key) ois.readObject();
      ois.close();
      fis.close();
      FileChiave = new File("PrivKey" + path + args[2]);
      fis = new FileInputStream(FileChiave);
      ois = new ObjectInputStream(fis);
      PrivKey = (Key) ois.readObject();
      ois.close();
      fis.close();
      // Chiavi relative alla lista dei riferimenti conosciuti
      for (int i=0 ; i<Lista.size(); i++) {
        EntryLista ent = (EntryLista) Lista.elementAt(i);
        FileChiave = new File("PubKey" + path + ent.Locazione);
        fis = new FileInputStream(FileChiave);
        ois = new ObjectInputStream(fis);
        Key keytemp = (Key) ois.readObject();
        KeyList.put(ent.Locazione,keytemp);
        ois.close();
        fis.close();
      }
    } catch (IOException ioe) {
        System.out.println ("Impossibile leggere la chiave pubblica...");
    } catch (ClassNotFoundException cnfe) {
        System.out.println ("Impossibile leggere la chiave pubblica...");
    }
    System.out.println ("Num. chiavi : " + KeyList.size());
    System.out.println ("AgentServer in esecuzione su " + SerHost + " : " + port);

    // Istanzio e faccio partire il thread controllore con un tempo di scansione 
    // di 15 minuti
    controllore = new ControlThread (15, agentServer, 0);
    controllore.setPriority(5);
    controllore.start();
 
    // Istanzio e faccio partire il thread di comando con una bassa priorita'
    command = new CommandThread (agentServer);
    command.setPriority(1);
    command.start();

    // Faccio partire il thread server con una priorita' maggiore
    agentServer.setPriority(8);
    agentServer.start();
   }
}
	
