package Agent;

import java.io.*;
import java.util.StringTokenizer;


// Classe di utilit per caricare il contenuto di un file .class dal CLASSPATH.
public class ClassBytesLoader {

  // Pu essere chiamata anche da altre classi
  public static byte[] loadClassBytes (String className) 
                                      throws IOException {				
     int size;
     byte[] classBytes;
     InputStream is;
     String fileSeparator = System.getProperty("file.separator");
     className = className.replace('.', fileSeparator.charAt(0));
     className = className + ".class";
     String classpath = System.getProperty("java.class.path");
     StringTokenizer st = new StringTokenizer (classpath, 
                               System.getProperty("path.separator"));
     File classFile = null;
     File dir = null;
     while ( st.hasMoreTokens() ) {
        dir = new File(st.nextToken());
        System.out.println ("directory : " + dir);
        classFile = new File(dir, className);
        if ( classFile.exists() )
          break;
     }
     FileInputStream fi = new FileInputStream (classFile);
     classBytes = new byte[fi.available()];
     fi.read (classBytes);
     return classBytes;
  }
}
