package Agent;

import java.io.*;
import java.net.*;
import java.util.*;

import java.security.*;

// Classe contenente il thread di comando
public class CommandThread extends Thread {

  // Riferimento al server
  AgentServerEx Server;
 
  // Costruttore
  public CommandThread ( AgentServerEx s) {
    // Assegno  il riferimento al server
    Server = s;
  }

  public void run() {
    String Comando = "";
    while ( (Comando.compareTo("exit") != 0) &&
            (Comando.compareTo("close") != 0 ) ) {
      BufferedReader dis = new BufferedReader (new InputStreamReader(System.in));
      try {
        Comando = dis.readLine();
      } catch ( IOException e ) {
          System.out.println("Errore : " + e.toString() );
      }
      if (Comando.length()>0)
        EsecuzioneComando(Comando,Server);
    }
    Server.controllore.stop();
    Server.stop();
    System.out.println ("Fine esecuzione server");
  }
  
  protected static void EsecuzioneComando(String Comando,AgentServerEx server) {
    // Prendo il separatore del path
    char path = System.getProperty("file.separator").charAt(0);
    if (Comando.compareTo("?") == 0) {
      // Comando di help
      System.out.println("Lista dei comandi :");
      System.out.println("?               -->  HELP!");
      System.out.println("tab             -->  STAMPA LA LISTA DI RIFERIMENTI CONOSCIUTI");
      System.out.println("status          -->  STAMPA LE VARIABILI DEL SERVER");
      System.out.println("add [tab]       -->  AGGIUNGE IL RIFERIMENTO ALLA TABELLA tab");
      System.out.println("rem [tab]       -->  ELIMINA IL RIFERIMENTO ALLA TABELLA tab");
      System.out.println("ver [versione]  -->  AGGIORNA LA VERSIONE DEI PROPRI RIFERIMENTI");
      System.out.println("time [time2live]  -->  ASSEGNA IL TIME TO LIVE DEI COORDAGENT");
      System.out.println("[nodo] [porta] [filechiave] -->  SI PUBBLICIZZA SU QUEL NODO");
      System.out.println("close           -->  TERMINA L'ESECUZIONE DEL SERVER");     
      System.out.println("exit            -->  PUBBLICIZZA L'USCITA DEL SERVER");      
      return;
    }
    if (Comando.compareTo("close")==0) {
      // Comando di terminazione
      return;
    }
    if (Comando.compareTo("status")==0) {
      // Stampa delle variabili
      System.out.println("Server --> " + server.SerHost + ":" + server.port );
      System.out.println("Versione : " + server.SerVer );
      System.out.println("Tempo di scansione : " + server.controllore.TempoScansione );
      System.out.println("Conteggio thread di controllo : " + server.controllore.Conteggio );
      System.out.println("Time to live CoordAgent : " + server.Time2LiveAgenti );
      return;
    }
    if (Comando.compareTo("tab")==0) {
      // Comando di stampa della lista dei riferimenti conosciuti
      System.out.println ("Server--> Mia lista di riferimenti conosciuti: ");
      for (int i=0; i<server.Lista.size(); i++) {
        EntryLista ent = (EntryLista) server.Lista.elementAt(i);
        System.out.println (ent.IDTabella + " " + ent.Locazione + " " + ent.Porta + " " + ent.Versione + " " + ent.Data);
      }
    if ( server.ListaEliminati.size() != 0 ) {
      System.out.println ("Server--> Mia lista di nodi scaduti: ");
      for (int i=0; i<server.ListaEliminati.size(); i++) {
        EntryLista ent = (EntryLista) server.ListaEliminati.elementAt(i);
        System.out.println ("LE: " + ent.IDTabella + " " + ent.Locazione + " " + ent.Porta + " " + ent.Versione + " " + ent.Data);
      }
    } else {
        System.out.println ("Server--> La mia lista dei nodi scaduti e' vuota");
      }
    System.out.println ("-----------------------");
    return;
   }
    if (Comando.compareTo("exit") == 0) {
      // Comando pubblicizzazione di uscita dal sistema
      ListaTabelle ListaNodi = new ListaTabelle();
      ListaTabelle ListaElimin = new ListaTabelle();
      // Preparo la lista dei riferimenti errati dell'agente con
      // i riferimanti a questo nodo mentre i restanti riferimenti
      // saranno aggiunti nella lista dei riferimenti conosciuti
      for(int i=0; i<server.Lista.size(); i++) { 
         EntryLista en = (EntryLista) server.Lista.elementAt(i);
         if ( en.Locazione.compareTo(server.SerHost) == 0 &&  en.Porta == server.port ) {
           ListaElimin.addElement(server.Lista.elementAt(i));
         } else {
             ListaNodi.addElement(server.Lista.elementAt(i));
           }
       }
       CoordAgent ExitCoordAgent = new CoordAgent (server.Time2LiveAgenti);// L'agente non fa ritorno
       ExitCoordAgent.SetListeNodo (ListaNodi, ListaElimin, server.KeyList);
       ExitCoordAgent.SetFirma (server.FirmaNodo);
       ExitCoordAgent.setPriority(8);
       ExitCoordAgent.start(); 
       System.out.println ("Pubblicizzata l'uscita del server");
       try {
         // Attesa del termine del thread per un minuto
         ExitCoordAgent.join(1000*60);
         if (ExitCoordAgent.isAlive())
           System.out.println ("Thread non terminato..."); 
       } catch (Exception e){
           System.out.println ("Impossibile pubblicizzare l'uscita del server!!!");
       }
       return;
     }
     try {      
       StringTokenizer st = new StringTokenizer(Comando," ");
       String cmd = st.nextToken();
       if (cmd.compareTo("add") == 0) {
         // Comando per aggiungere una tabella
         String NuovaTabella = st.nextToken();
         EntryLista NuovaEntry = new EntryLista(NuovaTabella,server.SerHost,server.port,server.SerVer,new Date());
         server.Lista.addElement(NuovaEntry);
         return;
       }
       if (cmd.compareTo("rem") == 0) {
         // Comando per togliere una tabella
         String VecchiaTabella = st.nextToken();
         EntryLista VecchiaEntry = new EntryLista(VecchiaTabella,server.SerHost,server.port,server.SerVer,new Date());
         server.Lista.DelRifErrati(VecchiaEntry);
         return;
       }
       if (cmd.compareTo("ver") == 0) {
         // Comando per modificare la versione
         int NuovaVer = Integer.parseInt(st.nextToken());
         if (NuovaVer > 0) {
           server.SerVer = NuovaVer;
           for (int i=0; i<server.Lista.size(); i++) { 
             EntryLista en = (EntryLista) server.Lista.elementAt(i);
             if ( (en.Locazione.compareTo(server.SerHost) == 0) &&  
                  (en.Porta == server.port) ) {
                    en.Versione = server.SerVer;
             }
           }
         }
         return;
       }
       if (cmd.compareTo("time") == 0) {
         // Comando per assegnare il time to live ai CoordAgent
         int NuovaT2L = Integer.parseInt(st.nextToken());
         if (NuovaT2L > 0) 
         server.Time2LiveAgenti = NuovaT2L;
         return;
       }
       // Comando di pubblicizzazione verso un nodo...
       // Locazone Porta FileChiave 
       String Locazione = cmd;
       int Porta = Integer.parseInt(st.nextToken());
       String Chiave = st.nextToken();
       // Leggo la chiave
       FileInputStream fis = new FileInputStream(new File("PubKey" + path + Chiave));
       ObjectInputStream ois = new ObjectInputStream(fis);
       Key PrivKeyDest = (Key) ois.readObject();
       server.KeyList.put(Locazione,PrivKeyDest);
       ois.close();
       fis.close();
       ListaTabelle ListaNodi = new ListaTabelle();
       // Preparazione lista per la migrazione
       ListaNodi.addElement( new EntryLista("*",server.SerHost,server.port,server.SerVer,new Date()) );
       ListaNodi.addElement( new EntryLista("*",Locazione,Porta,0,new Date()) );
       ListaNodi.ConfrontaListe(server.Lista);
       CoordAgent PubCoordAgent = new CoordAgent (server.SerHost,server.port,server.Time2LiveAgenti);// l'agente fara' ritorno
       PubCoordAgent.SetListeNodo (ListaNodi, new ListaTabelle(), server.KeyList); 
       PubCoordAgent.SetFirma (server.FirmaNodo);
       PubCoordAgent.setPriority(8);
       PubCoordAgent.start(); 
       return;
     } catch ( Exception e ) {  }
     System.out.println ("Comando errato!");
  } // Fine EseguiComando

}
