package Agent;

import java.io.*;
import java.net.*;
import java.util.*;


// Classe contenente il thread di controllo
public class ControlThread extends Thread {

  // Riferimento al server
  AgentServerEx server;
  // Tempo di scansione
  public int TempoScansione;
  // Variabile di conteggio
  public int Conteggio;

  // Costruttore
  public ControlThread (int t, AgentServerEx s, int Ciniz) {
    // Assegno il tempo di scansione e il riferimento al server
    TempoScansione = t;
    server = s;
    Conteggio = Ciniz;
  }

  public void run() {
    while(true) {
      // Se il conteggio e' arrivato al termine, si azzera e
      // si fa partire l'agente di coordinamento 
      if (Conteggio < TempoScansione) {
        Conteggio++;
      } else {
          // E' giunta l'ora di ripubblicizzare il nodo
          Conteggio = 0;
          CoordAgent MioCoordAgent = new CoordAgent (server.SerHost, server.port, server.Time2LiveAgenti);
          MioCoordAgent.SetListeNodo (server.Lista, new ListaTabelle(), server.KeyList);
          MioCoordAgent.SetFirma (server.FirmaNodo);
          MioCoordAgent.start(); 
        } 
      // Aggiornamento delle entry relative al server corrente
      // Aggiornamento versione prima di mandare il coordagent
      if (Conteggio == TempoScansione-1)
        server.SerVer++;
      Date Data = new Date();
      for (int i=0; i<server.Lista.size(); i++) { 
        EntryLista en = (EntryLista) server.Lista.elementAt(i);
        if ( (en.Locazione.compareTo(server.SerHost) == 0) &&  
             (en.Porta == server.port) ) {
          en.Versione = server.SerVer;
          en.Data = Data;
        }
      }
      // Controllo ed eliminazione di eventuali entry vecchie
      Date Scadenza = new Date();
      // Esempio: elimina le entry non aggiornate negli ultimi 4 cicli di CoordAgent...
      Scadenza.setTime(Scadenza.getTime()-(long)60000*TempoScansione*4);
      server.Lista.CheckEntryTime (Scadenza, server.ListaEliminati);
      // Elimina eventuali entry vecchie anche nella lista dei riferimenti eliminati
      Scadenza.setTime(Scadenza.getTime()-(long)60000*TempoScansione*4);
      server.ListaEliminati.CheckEntryTime(Scadenza);
      // Stampa delle liste
      System.out.println ("Server--> Mia lista di riferimenti conosciuti: ");
      for (int i=0; i<server.Lista.size(); i++) {
	EntryLista ent = (EntryLista) server.Lista.elementAt(i);
        System.out.println (ent.IDTabella + " " + ent.Locazione + " " + ent.Porta + " " + ent.Versione + " " + ent.Data);
      }
      if ( server.ListaEliminati.size() != 0 ) {
        System.out.println ("Server--> Mia lista di riferimenti scaduti: ");
        for (int i=0; i<server.ListaEliminati.size(); i++) {
	   EntryLista ent = (EntryLista) server.ListaEliminati.elementAt(i);
           System.out.println ("LE: " + ent.IDTabella + " " + ent.Locazione + " " + ent.Porta + " " + ent.Versione + " " + ent.Data);
        }
      } else {
          System.out.println ("Server--> La mia lista dei riferimenti scaduti e' vuota");
        }
      System.out.println ("-----------------------");
      try  {
        // Thread sospeso per 2 minuti
        Thread.sleep(2*60000) ;
      } catch(InterruptedException e) {
          System.out.println ("Sono guai: il controllore e' stato interrotto!!!!");
      }
    }
  }
}
	
