// Classe che genera una coppia di chiavi (pubblica e privata)
// e crea dei file contenenti firme di nodi

// package java.security

import java.io.*;
import java.util.*;
import java.security.*;
import iaik.security.provider.IAIK;
import javax.crypto.*;
import iaik.utils.CryptoUtils;


public class SigFileLab2 {

  public static void main (String argv[]) {
    Signature signature;
    byte[] realSignature;
    ObjectOutputStream oos;
    ObjectInputStream ois;
    String DefaultUrl = "127.0.0.1";
    String user = "certificatore";
    
    try {
      // Tento di creare le directory
      File dir = new File("Certif");
      if ( dir.mkdir() )
        System.out.println ("Creata dir Certif");  
      dir = new File("PrivKey");
      if ( dir.mkdir() )
        System.out.println ("Creata dir PrivKey");
      dir = new File("PubKey");
      if ( dir.mkdir() )
        System.out.println ("Creata dir PubKey");
  
      Provider iaik = new iaik.security.provider.IAIK();
      Security.addProvider(iaik);

      // Crea un digest
      MessageDigest md = MessageDigest.getInstance("SHA");
      String string = DefaultUrl  + user + (new Date()).toString();
      // Aggiorna l'oggetto digest
      md.update(string.getBytes());       
      KeyGenerator kg = KeyGenerator.getInstance("DES");
      // Calcolo del digest e inizializzazione 
      // Genera la coppia di chiavi
      Key key;
      for (int pippo = 0 ;pippo < 13 ; pippo++) {
        try {
          key = kg.generateKey();
          File filepub;
          File filepriv;
          if ( pippo < 10 ) {
            filepub = new File("PubKey/192.168.100.10" + pippo);
            filepriv = new File("PrivKey/192.168.100.10" + pippo);
          } else {
              filepub = new File("PubKey/192.168.100.1" + pippo);
              filepriv = new File("PrivKey/192.168.100.1" + pippo);
          }
          if (pippo == 0) {
            filepub = new File("PubKey/127.0.0.1");
            filepriv = new File("PrivKey/127.0.0.1");
          }
          FileOutputStream fispub = new FileOutputStream(filepub);
          ObjectOutputStream oospub = new ObjectOutputStream(fispub);
          oospub.writeObject(key);
          fispub.close();
          FileOutputStream fispriv = new FileOutputStream(filepriv);
          ObjectOutputStream oospriv = new ObjectOutputStream(fispriv);
          oospriv.writeObject(key);
          fispriv.close();
        } catch (Exception e) {
          System.err.println ("Errore..." + e);
        }
      }
      PublicKey pub;
      PrivateKey priv;
      KeyPair pair;
      KeyPairGenerator keygen = KeyPairGenerator.getInstance("DSA");
      keygen.initialize(512,new SecureRandom(md.digest()));
      pair = keygen.generateKeyPair();
      System.out.println ("Public-key:  " + pair.getPublic().getEncoded() + "   Private-key: " + 
   	   	         pair.getPrivate().getEncoded() + "\n");
      System.out.println ("Public-key:  " + pair.getPublic().toString());
      System.out.println ("Private-key: " + pair.getPrivate().toString());   
      // Estrae chiave privata 
      priv = pair.getPrivate();
      // Estrae chiave pubblica
      pub = pair.getPublic();

      try {
        File file3 = new File("PubKey/pubKey");
        FileOutputStream fis3 = new FileOutputStream(file3);
        oos = new ObjectOutputStream(fis3);
        oos.writeObject(pub);
        fis3.close();
        // Crea un oggetto Signature per firmare i dati e lo inizializza
        // con la chiave privata dell'autorita' di certificazione 
        signature = Signature.getInstance("DSA");
        for (int j=1; j<10; j++) {
          signature.initSign(priv);
          // Fornisce i dati da firmare per byte
          String Certif = "192.168.100.10" + j + " 1999";
          for (int i=0; i<Certif.length(); i++) {
            signature.update ((byte) Certif.charAt(i)); 
          }
          // Genera la firma
          realSignature = signature.sign();
          System.out.println ("realSignature " + j + "  : " + realSignature);
          File file2 = new File("Certif/192.168.100.10"+ j);
          FileOutputStream fis2 = new FileOutputStream(file2);
          fis2.write(realSignature);
          fis2.close();
        }
        for (int j=10; j<13; j++) {
          signature.initSign(priv);
          String Certif = "192.168.100.1" + j + " 1999";
          for (int i=0; i<Certif.length(); i++) {
            signature.update ((byte) Certif.charAt(i)); 
          }
          realSignature = signature.sign();
          System.out.println ("realSignature " + j + " : " + realSignature);
          File file2 = new File("Certif/192.168.100.1"+ j);
          FileOutputStream fis2 = new FileOutputStream(file2);
          fis2.write(realSignature);
          fis2.close();
        }

        signature.initSign(priv);
        String Certif = DefaultUrl + " 1999";
        for (int i=0; i<Certif.length(); i++) {
          signature.update ((byte) Certif.charAt(i)); 
        }
        realSignature = signature.sign();
        System.out.println ("realSignature  default : " + realSignature);
        File file2 = new File("Certif/127.0.0.1");
        FileOutputStream fis2 = new FileOutputStream(file2);
        fis2.write(realSignature);
        fis2.close();

        PublicKey pub2;
        File file4 = new File("PubKey/pubKey");
        FileInputStream fis4 = new FileInputStream(file4);
        ois = new ObjectInputStream(fis4);
        pub2= (PublicKey) ois.readObject();
        fis4.close();

        // Per verificare la firma, l'oggetto Signature viene inizializzato 
        // con la chiave pubblica dell'autorita' di certificazione
        signature.initVerify(pub2);
        for (int i=0; i<Certif.length(); i++) {
          signature.update ((byte) Certif.charAt(i)); 
        }
        // Verifica della firma
        if (signature.verify(realSignature)) {
          System.out.println("La firma corrisponde"); 
        } else {
            System.out.println("La firma non corrisponde"); 
          }

      } catch (Exception e) {
          System.err.println ("Errore..." + e);
      }
   } catch ( NoSuchAlgorithmException nsae ) {
       System.out.println ("Algoritmo inesistente!! " + nsae);
   }
 }
}


