// Agente di query

import Agent.*;
import java.io.*;
import java.util.*;
import java.net.*;

import java.security.* ;

public class QueryAgent extends SearchAgent {

  // Indicazione del risultato della query
  protected String RisultatoQuery = "";
	 
  public QueryAgent (String s, int p, Hashtable Arr, byte firm[], Hashtable kl) {
    // stato iniziale di ricerca tabelle (1) e NNodiVisitati a 0
    super (s, p, Arr, 1, 0, firm, kl);
    AgentName = "QueryAgent";
  }


  // Metodo di inizio attivit dell'agente
  protected void execute() throws AgentException {
    System.out.println ("Salve sono l'agente " + AgentName());
    System.out.println ("QA--> Inizio la ricerca da: " + host + " : " + port);
    // Inserimento entry relativa al nodo da cui si inizia la ricerca 
    EntryLista en = new EntryLista ("*", host, port, 0, new Date());
    ListaNodo.addElement(en); 
    HostPrincipal = host;
    PortPrincipal = port;
    MigraSuNodo();	
  }


  // Metodo di migrazione dell'agente
  protected void MigraSuNodo() {
    // Se non ci sono piu' nodi da visitare 
    // o il Time to Live  scaduto termina  
    while (( ListaNodo.size() > NNodiVisitati) && (Time2Live > 0)) { 
      // Tentativo di migrazione
      System.out.println ("QA--> Tento la migrazione..."); 
      EntryLista en;
      en = (EntryLista) ListaNodo.elementAt(NNodiVisitati);
      try {
        if (ListaNodo.CheckLocazione(en.Locazione, en.Porta, NNodiVisitati)) {
          // Non migra su un nodo gia' visitato, ma
          // incrementa comunque il numero nodi visitati..
          NNodiVisitati++;
          System.out.println ("QA--> Su questo nodo ci sono gia' stato... : " + en.Locazione +
                              " : " + en.Porta);
        } else {
            String OldLoc = HostLoc;
            int OldPort = HostPort;
            try {
              Log = Log + " " + Stato + " " + en.Locazione + " : " + en.Porta + "\n";
              System.out.println ("Log: <stato>  <locazione>  <porta>");
              System.out.println (Log);
              // Salvataggio delle informazioni sul nodo dove si sta migrando
              HostLoc = en.Locazione;
              HostPort = en.Porta;
              // Tentativo di migrazione
              migrate (en.Locazione, en.Porta);
              return;         
            } catch (AgentException ae) {
                // Reinserico i valori corretti
                HostPort = OldPort ;
                HostLoc = OldLoc ;
                Log = Log + "Tentativo fallito..." + "\n";
                System.out.println ("QA--> " + ae.toString());
                // Elimina la entry del nodo che ha causato l'errore
                ListaNodo.removeElementAt(NNodiVisitati);
                System.out.print ("QA--> Eliminata la entry : "); 
                System.out.println (en.IDTabella + " " + en.Locazione + " " + 
                                    en.Porta + " " + en.Versione + " " + en.Data);
            }
          }
      } catch (Exception e) { 
          System.out.println ("QA--> Errore durante il check della lista");   
      }
    }
    System.out.println ("QA--> Siamo arrivati in fondo alla lista... ");
    System.out.println ("QA--> Purtroppo la query e' fallita.. mi dispiace!!  :-(");
    try {
      // valori di  prova...
      // HostPrincipal =  "192.168.100.107";  // HostPrincipal =  "127.0.0.1";
      // PortPrincipal =  10000; 
      // Settaggio dello stato di fine ricerca
      Stato = 4; 
      migrate (HostPrincipal, PortPrincipal);
      // Stampa in un file il LOG e stampa il file appena creato
      File LogFile = new File ("./LogFile.txt");
      RandomAccessFile file = new RandomAccessFile(LogFile, "rw");
      file.writeBytes(Log);
      return;         
    } catch (AgentException ae) {
        // Migrazione di ritorno fallita
        System.out.println ("QA--> Migrazione di ritorno fallita :-(( ");
    } catch (IOException ioe) {
        System.out.println ("QA--> IOError " + ioe.toString());
    }
  }


  // Metodo chiamato all'arrivo su un sito remoto	 
  public void onArrival(AgentServer server) throws AgentException {

     // Aggiornamento delle liste a carico dell'agente...
     System.out.println ("QA--> Liste date all'agente per l'aggiornamento ");
     SetListeNodo (server.Lista, server.ListaEliminati, server.KeyList);
     // Si da' la firma all'agente...
     SetFirma (server.FirmaNodo);

     // Incremento del numero di nodi visitati
     if (Stato == 1) 
       NNodiVisitati++;
     // Decremento del Time to live
     Time2Live--;
     System.out.println ("QA--> Salve, sono l'agente " + AgentName() + " appena arrivato...");
     // Visualizzazione delle liste sul nodo di arrivo
     System.out.println ("QA--> Questa e' la mia lista dei riferimenti conosciuti (" + NNodiVisitati +"): ");
     EntryLista en;
     for (int i=0; i<ListaNodo.size(); i++) {
        en = (EntryLista) ListaNodo.elementAt(i);
	System.out.println (en.IDTabella + " " + en.Locazione + " " +
                            en.Porta + " " + en.Versione + " " + en.Data);
     }
     if ( ListaRifErrati.size() != 0 ) {
       System.out.println ("QA--> Questa e' la mia lista dei riferimenti errati: ");
       for (int i=0; i<ListaRifErrati.size(); i++) {
          en = (EntryLista) ListaRifErrati.elementAt(i);
	  System.out.println (en.IDTabella + " " + en.Locazione + " " +
                              en.Porta + " " + en.Versione + " " + en.Data);
       }
     } else {
         System.out.println ("QA--> La mia lista dei riferimenti errati e' vuota");
       }
     try {
       LeggiStato();
     } catch (Exception e){
         System.out.println ("QA--> Errore di stato: " + e.toString());
       }
  }


  // Metodo di analisi dello stato di esecuzione dell'agente
  protected void LeggiStato() throws Exception {
     switch (Stato) {
        case 1:
          RicercaTabelle();
          break;
        case 2:
          EsecuzioneQuery();
          break;
       	case 3:
          System.out.println ("QA--> Query terminata con successo :");
          System.out.println (RisultatoQuery);
	  System.out.println ("QA--> Sono arrivato a casa... termino la mia esecuzione!!!");
          System.out.println ("File di LOG:");
          System.out.println (Log);
	  break;
        case 4:
          System.out.println ("QA--> Query terminata con insuccesso, risultato parziale:");
          System.out.println (RisultatoQuery);
          System.out.println ("QA--> ... termino la mia esecuzione!!!");
          System.out.println ("File di LOG:");
          System.out.println (Log);
          break;
        default:
          throw new Exception ("QA--> Stato non corretto!!"); 
     }
  }


  // Metodo di verifica della presenza di tutte le tabelle interessate dalla query
  protected void RicercaTabelle() {
     int i=0;      
     Hashtable ArrayTemp = new Hashtable();
     while ( i < ListaNodo.size() ) { 
	EntryLista en;
        en = (EntryLista) ListaNodo.elementAt(i);
        if (ArrayTabelle.containsKey(en.IDTabella)) {
          ArrayTemp.put (en.IDTabella, en.IDTabella);
        }	
        i++;
     }
     if (ArrayTemp.size() == ArrayTabelle.size()) {
       System.out.println ("QA--> Trovate tutte le tabelle, inizio l'esecuzione delle query... :-)");
       EntryLista en;
       // Ricerca delle tabelle presenti su quel nodo 
       // --> esecuzione locale della query prima di migrare
       CercaTabLocali (HostLoc, HostPort);
       // Tabelle tutte trovate: cambio stato...
       Stato = 2;          
       MigraSuNodo2();  
     } else {
         System.out.println ("QA--> Non trovate tutte le tabelle, proseguo la ricerca... :-(");
         MigraSuNodo();
       }
  }


  // Metodo di ricerca locale di tabelle ed esecuzione della relativa query
  protected void EsecuzioneQuery() {
     EntryLista en;
     if ( ! CercaTabLocali(HostLoc, HostPort) ) {
       System.out.println ("QA--> Tabella non trovata!!!... :-(");
       // Una tabella non e' stata trovata... il SearchAgent andra' a cercarla
       // solo quando il QueryAgent avra' finito di eseguire le query 
       // sulle tabelle trovate
     }
     MigraSuNodo2();            
  }


  // Metodo di invio e attesa dell'agente di ricerca delle tabelle non trovate	
  protected void CreaAgent () {
     int i = 0;
     int Portattesa = 60000;  // per ora optiamo per una porta fissa...
     Socket SocketAttesa;
     ServerSocket ServerSocketAttesa; 

     // Invio SearchAgent e attesa del suo ritorno... 
     System.out.println ("QA--> Il SA dovra' tornare  su : " + HostLoc + ":" + HostPort);
     SearchAgent AgenteDiRicerca = new SearchAgent (HostLoc, HostPort, ArrayTabelle, 1,
                                                    NNodiVisitati+1, FirmaBytes, KeyList);
     AgenteDiRicerca.SetListeNodo (ListaNodo, ListaRifErrati, KeyList);
     // Non trovate tutte le tabelle: prosegue la ricerca il SearchAgent...
     AgenteDiRicerca.run();
     try {
        System.out.println ("QA--> mi metto in attesa del SearchAgent...");
        ServerSocketAttesa = new ServerSocket(Portattesa);
        // Controllo per evitare attesa illimitata... si aspetta per 5 minuti (esempio)
        ServerSocketAttesa.setSoTimeout (5*60*1000); 
        SocketAttesa = ServerSocketAttesa.accept();
        // Al ritorno, l'agente di ricerca passera' le sue liste...
        ObjectInputStream IN = new ObjectInputStream(SocketAttesa.getInputStream());
        ListaTabelle Risultato = new ListaTabelle();
        ListaTabelle RisultatoErr = new ListaTabelle();
        Hashtable RisultatoKey = new Hashtable();
        String RisultatoLog;
        Boolean RisultatoOK;
        RisultatoOK = (Boolean) IN.readObject();
        Risultato = (ListaTabelle) IN.readObject();
        System.out.println ("QA--> Ricevuta la lista dei riferimenti conosciuti...");
        EntryLista ent;
        for (i=0; i<Risultato.size(); i++) {
          ent= (EntryLista) Risultato.elementAt(i);
          System.out.println ("QA--> " + ent.IDTabella + " " + ent.Locazione + " " + ent.Porta + 
                              " " + ent.Versione);
        }
        RisultatoErr = (ListaTabelle) IN.readObject();
        System.out.println ("QA--> Ricevuta la lista dei riferimenti errati...");
        for (i=0; i<RisultatoErr.size(); i++) {
          ent= (EntryLista) RisultatoErr.elementAt(i);
          System.out.println ("QA--> " + ent.IDTabella + " " + ent.Locazione + " " + ent.Porta + 
                              " " + ent.Versione);
        }
        RisultatoKey = (Hashtable) IN.readObject();
        RisultatoLog = (String) IN.readObject();
        IN.close();
        SocketAttesa.close();
        ServerSocketAttesa.close();  
        // Aggiornamento delle liste e del Log di QueryAgent con quelle di SearchAgent
        ListaRifErrati.ConfrontaListe (RisultatoErr);
        SetListeNodo (Risultato, RisultatoErr, RisultatoKey);
        Log = Log + RisultatoLog;
        if (RisultatoOK.booleanValue()) {
          MigraSuNodo2();
        } else {
            System.out.println ("QA--> Il SearchAgent ha fallito la ricerca... ");
            System.out.println ("QA--> Termino la mia esecuzione.. :-|");          
            System.out.println ("QA--> Siamo arrivati in fondo alla lista... ");
            System.out.println ("QA--> Purtroppo la query e' fallita.. mi dispiace!!  :-(");
            try {
              // valori di  prova...
              // HostPrincipal =  "192.168.100.107";  // HostPrincipal =  "127.0.0.1";
              // PortPrincipal =  10000; 
              // Settaggio dello stato di fine ricerca
	      Stato = 4; 
              HostLoc = HostPrincipal;
              HostPort = PortPrincipal; 
              migrate (HostPrincipal, PortPrincipal);
              // Stampa in un file il LOG e stampa il file appena creato
              File LogFile = new File ("./LogFile.txt");
              RandomAccessFile file = new RandomAccessFile(LogFile, "rw");
              file.writeBytes(Log);
            } catch (AgentException ae) {
                // Migrazione di ritorno fallita
                System.out.println ("QA--> Migrazione di ritorno fallita :-(( ");
            } catch (IOException ioe) {
                System.out.println ("QA--> IOError " + ioe.toString());
            }
          } 
        } catch (InterruptedIOException ie) {
            System.out.println ("QA--> Errore: tempo di attesa del SearchAgent scaduto !! " + ie.toString());
            System.out.println ("QA--> Termino l'esecuzione :-(( ");
        } catch (IOException ioe) {
            System.out.println ("QA--> Errore di rete nella comunicazione di ritorno!! " + ioe.toString());
            System.out.println ("QA--> Termino l'esecuzione :-(( ");
        } catch (ClassNotFoundException cnfe) {
            System.out.println ("QA--> Errore classe non trovata!! " + cnfe.toString());
            System.out.println ("QA--> Termino l'esecuzione :-(( ");
        } 
        Time2Live = 0;
   }
  
  
  // Metodo di migrazione chiamato durante la verifica della presenza effettiva delle tabelle
  protected void MigraSuNodo2 () {
    if ( ArrayTabelle.size() == 0 ) {
      // Tutte le query eseguite.... si torna al nodo di partenza 
      // Si tenta per 3 volte, poi la query fallisce
      for (int Tentativo=1 ; Tentativo<4; Tentativo++) {
         try {
           // valori di  prova...
           // HostPrincipal =  "192.168.100.107";  // HostPrincipal =  "127.0.0.1";
           // PortPrincipal =  10000; 
           // Settaggio dello stato di fine ricerca
	   Stato = 3;
           HostLoc = HostPrincipal;
           HostPort = PortPrincipal; 
           migrate (HostPrincipal, PortPrincipal);
           // Stampa in un file il LOG e stampa il file appena creato
           File LogFile = new File ("./LogFile.txt");
           RandomAccessFile file = new RandomAccessFile(LogFile, "rw");
           file.writeBytes(Log);
           return ;         
         } catch (AgentException ae) {
             // Migrazione di ritorno fallita
             System.out.println ("QA--> Migrazione di ritorno numero " + Tentativo + " fallita :-(( ");
             try {
               this.sleep(10000 *Tentativo);
             } catch ( InterruptedException  ie ) {
                System.out.println ("QA--> Attesa interrotta "); 
               }
         } catch (IOException ioe) {
             System.out.println ("QA--> IOError " + ioe.toString());
         }
      }
      // Migrazione di ritorno fallita definitivamente
      System.out.println ("QA--> Migrazione di ritorno fallita definitivamente !!! :-(( ");
      Time2Live = 0;
     }
     // Se il Time to Live  scaduto termina  
     while ( Time2Live > 0 ) { 
       // Tentativo di migrazione
       System.out.println ("QA--> Tento la migrazione..."); 
       EntryLista en;
       // Se la tabella e' presente nell'ArrayTabelle ed e' locale
       for (int i=0; i<ListaNodo.size(); i++) {
	  en = (EntryLista) ListaNodo.elementAt(i);
          try {
            if ( (ArrayTabelle.containsKey(en.IDTabella)) ) { 
	      // Migra solo su un nodo dove e' presente una tabella che interessa
              String OldLoc = HostLoc;
              int OldPort = HostPort;
     	      try {
                Log = Log + " " + Stato + " " + en.Locazione + " : " +  en.Porta + "\n";
                System.out.println ("Log: <stato>  <locazione>  <porta>");
                System.out.println (Log);
                // Salvataggio delle informazioni sul nodo dove si sta migrando
                HostLoc = en.Locazione;
                HostPort = en.Porta;
                // Tentativo di migrazione
                migrate (en.Locazione, en.Porta);
                return;         
     	      } catch (AgentException ae) {
                  // Reinserico i valori corretti
                  HostPort = OldPort ;
                  HostLoc = OldLoc ;
                  Log = Log + "Tentativo fallito..." + "\n";
     	          // Elimina la entry del nodo che ha causato l'errore 
                  // Se e' il caso, si adegua NNodiVisitati
     	          if ( i <= NNodiVisitati ) {
     	            NNodiVisitati--;
     	          }
                  ListaNodo.removeElementAt(i);
     	          i--;
		  System.out.print ("QA--> Eliminata la entry:"); 
    	          System.out.println (en.IDTabella + " " + en.Locazione +  " " + en.Porta + " "
                                      + en.Versione + " " + en.Data);
     	      }
     	    }
     	  } catch (Exception e) { 
     	      System.out.println ("QA--> Errore durante il check della lista");   
     	  }
       } 
       System.out.println ("QA--> Siamo arrivati in fondo alla lista... bisogna iniziare di nuovo la ricerca...");
       System.out.println ("QA--> Lancio quindi SearchAgent alla ricerca delle tabelle non trovate...");
       // Lancio di SearchAgent alla ricerca delle tabelle non trovate...
       CreaAgent();
     } 
  }   


  // Metodo di ricerca di tabelle su un nodo
  protected boolean CercaTabLocali (String Locazione, int Porta) {
     // Per ogni entry della lista riferimenti conosciuti, 
     // si controlla se e' presente nell'ArrayTabelle 
     EntryLista en;
     boolean Modifica = true;
     System.out.println ("QA--> Ricerca su " + Locazione + ":" + Porta );
     for (int i=0; i<ListaNodo.size(); i++) {
       en = (EntryLista) ListaNodo.elementAt(i);
       // Se la tabella e' presente nell'ArrayTabelle ed e' locale:
       if ( ArrayTabelle.containsKey(en.IDTabella) &&
     	    (en.Porta == Porta)  &&
     	    (en.Locazione.compareTo(Locazione) == 0) )  {
          // In questa situazione si eseguira' la query
     	  System.out.println ("QA--> Esecuzione Query locale sulla tabella " + en.IDTabella);
       	  if ( EseguiSQL(en.IDTabella) ) {
     	    // Se viene eseguita una query, elimina il riferimento alla tabella da ArrayTabelle
    	    ArrayTabelle.remove(en.IDTabella);
    	  } else {
              System.out.println ("QA--> Fallita Query locale sulla tabella " + en.IDTabella);
      	      Modifica = false;
     	    }
       }
     }	
     // Ricerca in ListaRifErrati eventuali riferimenti sbagliati relativi a tabelle 
     // interessate dalla query, ma non presenti sul nodo corrente
     for (int i=0; i<ListaRifErrati.size(); i++) {
       en = (EntryLista) ListaRifErrati.elementAt(i);
       // Se la tabella contenuta nella entry di ListaRifErrati selezionata e' una tabella
       // da cercare e tale tabella e' relativa al nodo su cui siamo (locazione && porta)
       // e non ci sono altri riferimenti a quella tabella nella lista del nodo 
       // (relativi a copie della stessa tabella presenti su altri nodi...)
       if ( (ArrayTabelle.containsKey(en.IDTabella))  && 
            (en.Porta == Porta) &&
            (en.Locazione.compareTo(Locazione) == 0) ) {
         try {
	   ListaNodo.GetLocazione(en.IDTabella);
           // La entry non interessa, poiche' e' presente un altro riferimento 
           // alla tabella interessata nella lista dei riferimenti conosciuti
         } catch ( Exception e ) {
             Modifica = false;
         }
       }
     }   
     return Modifica;
   }


  // Metodo che esegue la query SQL sulla tabella passata
  protected boolean EseguiSQL (String IDTabella) {
    // Eventuale metodo che esegue le query...
    try {
      File myFile = new File(IDTabella);
      if (myFile.exists() && myFile.canRead()) {
        // Se il file relativo alla tabella  esiste ed e' leggibile comincia a lavorare  
        RandomAccessFile file = new RandomAccessFile (myFile, "r");
        while (file.getFilePointer() < file.length()) {
          String lettura = file.readLine();
          RisultatoQuery = RisultatoQuery + lettura + "\r\n";
        }
        System.out.println ("QA--> Eseguita query su tabella " + IDTabella);
        return true;
      } else {
          System.out.println ("QA--> Errore accesso alla tabella " + IDTabella);
          return false;
      }
    } catch (Exception e) {
        System.out.println ("QA--> Errore query su tabella " + IDTabella + " ... " + e.toString());
        return false;
    }
  }

 
  public static void main (String args[]) throws Exception {
    // Prendo il separatore del path
    char path = System.getProperty("file.separator").charAt(0);
    // Parametri: nodo a cui ci si deve collegare per iniziare la query
    // (locazione e porta) e tabelle da cercare
    Hashtable Array = new Hashtable();
    if ( args.length > 2) { 
      host = args[0];
      port = Integer.parseInt(args[1]);
      // Tabelle interessate dalla query (da cercare)
      for (int i=3; i<args.length; i++) {
         // Inserimento di coppia chiave-valore: idtab-idtab
         Array.put (args[i], args[i]); 
      }
    } else {
       throw new Exception ("Errore nei parametri: QueryAgent <host_dest> <port_dest> <certif. nodo> <tab1> <tab2> .. <tabN>");
      }
    File FileFirma = new File(args[2]);
    FileInputStream firm = new FileInputStream("Certif" + path + FileFirma);
    byte FirmaNodo[] = new byte[50];
    try {
      firm.read(FirmaNodo);        
      File FileChiave = new File ("PubKey" + path + args[0]);
      System.out.println ("Leggo chiave pubblica..." + args[0]);
      FileInputStream fis = new FileInputStream(FileChiave);
      ObjectInputStream ois = new ObjectInputStream(fis);
      Key keytemp = (Key) ois.readObject();
      Hashtable ht = new Hashtable();
      ht.put (host, keytemp);
      ois.close();
      fis.close();

      (new QueryAgent(host, port, Array,FirmaNodo, ht)).start();
    } catch (IOException ioe) {
        System.out.println ("Impossibile leggere la firma...");
    }
  }

}
